/*
 * Enhydra Java Application Server
 * The Initial Developer of the Original Code is Lutris Technologies Inc.
 * Portions created by Lutris are Copyright (C) 1997-2000 Lutris Technologies
 * Inc.
 * All Rights Reserved.
 *
 * The contents of this file are subject to the Enhydra Public License Version
 * 1.0 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://www.enhydra.org/software/license/epl.html
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under the
 * License.
 *-----------------------------------------------------------------------------
 * $Id: JEntityCmp2.vm,v 1.30 2003/03/31 15:39:39 joaninh Exp $
 *-----------------------------------------------------------------------------
 */

//
// This class is the bean specific part of the container managed persistence with JDBC.
// Generated by JOnAS's GenIC tool via Velocity.
// DO NOT EDIT THIS FILE.
//
package com.titan.cruise;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;

import javax.ejb.CreateException;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBException;
import javax.ejb.EJBHome;
import javax.ejb.EJBObject;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.ObjectNotFoundException;
import javax.ejb.RemoveException;

import org.objectweb.util.monolog.api.BasicLevel;

import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PBinding;
import org.objectweb.jorm.api.PClassMapping;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.api.PExceptionExistingDSI;
import org.objectweb.jorm.api.PExceptionIO;
import org.objectweb.jorm.naming.api.PExceptionNaming;
import org.objectweb.jorm.naming.api.PBinder;
import org.objectweb.jorm.naming.api.PExceptionExisting;
import org.objectweb.jorm.naming.api.PName;
import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.type.api.PTypeSpace;

import org.objectweb.jonas_ejb.container.jorm.Coder;
import org.objectweb.jonas_ejb.container.jorm.GenClassElement;
import org.objectweb.jonas_ejb.container.jorm.GenClassListener;
import org.objectweb.jonas_ejb.container.jorm.MedorFactory;
import org.objectweb.jonas_ejb.container.jorm.PObject;
import org.objectweb.jonas_ejb.container.jorm.PObjectHome;
import org.objectweb.jonas_ejb.container.JEntityContext;
import org.objectweb.jonas_ejb.container.JEntitySwitch;
import org.objectweb.jonas_ejb.container.JEntityFactory;
import org.objectweb.jonas_ejb.container.TraceEjb;
import org.objectweb.jonas_ejb.lib.MarshallTool;
import org.objectweb.jonas_ejb.lib.JavaType;
import org.objectweb.jonas_ejb.lib.ExceptionHelper;

import org.objectweb.medor.api.MedorException;
import org.objectweb.medor.api.TupleStructure;
import org.objectweb.medor.filter.api.ParameterOperand;
import org.objectweb.medor.filter.lib.BasicParameterOperand;
import org.objectweb.medor.tuple.api.Tuple;
import org.objectweb.medor.tuple.api.TupleCollection;
import org.objectweb.medor.type.lib.PTypeSpaceMedor;

public class JOnASCruiseEJBBean extends com.titan.cruise.CruiseBean implements PAccessor,
                                             jorm.Cmp2_CruiseAccessor
{

    private java.lang.String name;
    
    private java.lang.Integer id;
    
    private com.titan.ship.ShipLocal ship = null;
    private PName shipPName = null;
    
    private org.objectweb.jonas_ejb.container.jorm.Set reservations = null;
    private PName reservationsPName = null;
    
    protected JEntityContext ejbContext = null;
    private MedorFactory factory = null;
    private boolean dirty = false;
    private boolean setPkAllowed = false;

    //-------------------------------------------------------------//
    //------------------- Field  name
    //-------------------------------------------------------------//
    // EJB 2.0 Getter
    public java.lang.String getName() {
        TraceEjb.interp.log(BasicLevel.DEBUG, "return " + name);
        return name;
    }
    
    // EJB 2.0 Setter
    public void setName(java.lang.String val) {
        TraceEjb.interp.log(BasicLevel.DEBUG,"param=" + val);
        dirty = true;
        this.name = val;
    }
    
    // Jorm Getter
    public java.lang.String paGetName() {
        TraceEjb.interp.log(BasicLevel.DEBUG, "return " + name);
        return (java.lang.String) name;
    }
    
    // Jorm Setter
    public void paSetName(java.lang.String val) {
        TraceEjb.interp.log(BasicLevel.DEBUG, "param=" + val + " / current=" + name);
        this.name = (java.lang.String) val;
    }
    
    
    //-------------------------------------------------------------//
    //------------------- Field  id
    //-------------------------------------------------------------//
    // EJB 2.0 Getter
    public java.lang.Integer getId() {
        TraceEjb.interp.log(BasicLevel.DEBUG, "return " + id);
        return id;
    }
    
    // EJB 2.0 Setter
    public void setId(java.lang.Integer val) {
        TraceEjb.interp.log(BasicLevel.DEBUG,"param=" + val);
        if (!setPkAllowed) {
            throw new IllegalStateException("Must not reset a primary key value(id field)");
        }
        dirty = true;
        this.id = val;
    }
    
    // Jorm Getter
    public java.lang.Integer paGetId() {
        TraceEjb.interp.log(BasicLevel.DEBUG, "return " + id);
        return (java.lang.Integer) id;
    }
    
    // Jorm Setter
    public void paSetId(java.lang.Integer val) {
        TraceEjb.interp.log(BasicLevel.DEBUG, "param=" + val + " / current=" + id);
        this.id = (java.lang.Integer) val;
    }
    
    
     //-------------------------------------------------------------//
    //------------------- Field  ship
    //-------------------------------------------------------------//
    
    private void loadCMRShip() {
        if (ship == null) {
            TraceEjb.interp.log(BasicLevel.DEBUG,"load reference" + shipPName);
            try {
                ship = (com.titan.ship.ShipLocal) getPObject(shipPName, true);
            } catch (PException pe) {
                TraceEjb.logger.log(BasicLevel.ERROR, "impossible to load the reference", pe);
                throw new EJBException("Impossible to load the reference", pe);
            }
        }
    }
    
    private void clearShip() throws RemoveException {
        loadCMRShip();
        if (ship != null) {
            ((com.titan.ship.JOnASShipEJBCoherenceHelper) ship).jonasSetJonasCMRCruise_Ship(null);
        }
        shipPName = null;
        ship = null;
        dirty = true;
    }
    
    
    // ------------------------  E J B   G E T T E R  ---------------------- //
    //-----------------------------------------------------------------------//
    public com.titan.ship.ShipLocal getShip() {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG,"ship=" + ship);
        TraceEjb.coherence.log(BasicLevel.DEBUG,"shipPName=" + shipPName);
        if (shipPName != null)
            TraceEjb.interp.log(BasicLevel.DEBUG, "shipPName.isNull(): " + shipPName.isNull());
        loadCMRShip();
        TraceEjb.coherence.log(BasicLevel.DEBUG, "return " + ship);
        return ship;
    }
    
    // ------------------------  E J B   S E T T E R  ---------------------- //
    //-----------------------------------------------------------------------//
    public void setShip(com.titan.ship.ShipLocal val) {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG, "param=" + val);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "ship=" + ship);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "shipPName=" + shipPName);
        if (shipPName != null) {
            TraceEjb.interp.log(BasicLevel.DEBUG, "shipPName.isNull(): " + shipPName.isNull());
        }
        if (val != null && val instanceof PObject) {
            TraceEjb.interp.log(BasicLevel.DEBUG, "val.getPName(): " + ((PObject) val).getPName());
        }
        loadCMRShip();
        if (val == null || !val.equals(ship)) {
            JOnASCruiseEJBCoherenceHelper current = (JOnASCruiseEJBCoherenceHelper)
                                          ejbContext.getEJBLocalObject();
            if (ship != null) {
                ((com.titan.ship.JOnASShipEJBCoherenceHelper) ship).jonasRemoveJonasCMRCruise_Ship(current);
            }
            if (val != null) {
                ((com.titan.ship.JOnASShipEJBCoherenceHelper) val).jonasAddJonasCMRCruise_Ship(current);
            }
            shipPName = null;
            ship = val;
            dirty = true;
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG, "end: ship=" + ship);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "end: shipPName=" + shipPName);
    }
    
    // -------------------  J O R M   A C C E S S O R S  ------------------- //
    //-----------------------------------------------------------------------//
    
    // Jorm Getter
    public java.lang.Object paGetShip(java.lang.Object conn)
                                                      throws PExceptionIO {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG, "shipPName=" + shipPName);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "ship=" + ship);
        if ( shipPName==null) {
            if (ship!=null) {
				shipPName = ((PObject) ship).getPName();
            } else {
                shipPName = factory.getPNameManager("ship").getNull();
            }
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG,"return " + shipPName);
        return shipPName;
    }
    
    // Jorm Setter
    public void paSetShip(java.lang.Object o, java.lang.Object conn)
                                          throws PExceptionIO {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        this.ship = null;
        if (!(o instanceof PName)) {
            throw new PExceptionIO("Unexpected value: required PName: found " + o);
        }
        shipPName = (PName) o;
        TraceEjb.coherence.log(BasicLevel.DEBUG, "shipPName: " + shipPName);
        if (shipPName != null)
            TraceEjb.coherence.log(BasicLevel.DEBUG, "shipPName.isNull(): " + shipPName.isNull());
    }
    
    
    // IMPLEMENTATION OF THE com.titan.cruise.JOnASCruiseEJBCoherenceHelper INTERFACE //
    //-------------------------------------------------------------//
    public com.titan.ship.JOnASShipEJBCoherenceHelper jonasGetShip() {
        loadCMRShip();
        TraceEjb.coherence.log(BasicLevel.DEBUG, "return " + ship);
        return (com.titan.ship.JOnASShipEJBCoherenceHelper) ship;
    }
    
    public void jonasSetShip(com.titan.ship.JOnASShipEJBCoherenceHelper val) {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        if (val == null || !val.equals(ship)) {
            shipPName = null;
            ship = (com.titan.ship.ShipLocal) val;
            dirty = true;
        }
    }
    
    
    //-------------------------------------------------------------//
    //------------------- Field  reservations
    //-------------------------------------------------------------//
    
    
    // ------------------------  E J B   G E T T E R  ---------------------- //
    //-----------------------------------------------------------------------//
    public java.util.Collection getReservations() {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG,"reservations=" + reservations);
        TraceEjb.coherence.log(BasicLevel.DEBUG,"reservationsPName=" + reservationsPName);
        if (reservationsPName != null)
            TraceEjb.interp.log(BasicLevel.DEBUG, "reservationsPName.isNull(): " + reservationsPName.isNull());
        TraceEjb.coherence.log(BasicLevel.DEBUG, "return " + reservations);
        return reservations;
    }
    
    // ------------------------  E J B   S E T T E R  ---------------------- //
    //-----------------------------------------------------------------------//
    public void setReservations(java.util.Collection val) {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG, "param=" + val);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "reservations=" + reservations);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "reservationsPName=" + reservationsPName);
        if (reservationsPName != null) {
            TraceEjb.interp.log(BasicLevel.DEBUG, "reservationsPName.isNull(): " + reservationsPName.isNull());
        }
        if (val != null && val instanceof PObject) {
            TraceEjb.interp.log(BasicLevel.DEBUG, "val.getPName(): " + ((PObject) val).getPName());
        }
        if (val == null)
            throw new IllegalArgumentException("Assign a null value to a multivalued relationship");
        if (val != reservations) {
            // clear the current gen class
            reservations.clear();
            
            // iterate over the parameter to add each element into the
            // current gen class
            for(Iterator it = val.iterator(); it.hasNext();) {
                reservations.add(it.next());
            }
            dirty = true;
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG, "end: reservations=" + reservations);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "end: reservationsPName=" + reservationsPName);
    }
    
    // -------------------  J O R M   A C C E S S O R S  ------------------- //
    //-----------------------------------------------------------------------//
    
    // Jorm Getter
    public java.lang.Object paGetReservations(java.lang.Object conn)
                                                      throws PExceptionIO {
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        TraceEjb.coherence.log(BasicLevel.DEBUG, "reservationsPName=" + reservationsPName);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "reservations=" + reservations);
        if (reservationsPName == null) {
            try {
                reservationsPName = factory.getPNameManager("reservations")
                                  .export(conn, reservations.gcGetPBinding(),
                                          (PName) ejbContext.getEntitySwitch().getPrimaryKey());
            } catch (PExceptionIO e) {
                throw e;
            } catch (PException e) {
                throw new PExceptionIO(e, "Impossible to fetch a PName of the 'reservations' field");
            }
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG,"return " + reservationsPName);
        return reservationsPName;
    }
    
    // Jorm Setter
    public void paSetReservations(java.lang.Object o, java.lang.Object conn)
                                          throws PExceptionIO {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        // TraceEjb.coherence.log(BasicLevel.DEBUG,"bean pname:" + ((JEntitySwitch) ejbContext.getEntitySwitch()).getPrimaryKey());
        if (!(o instanceof PName)) {
            throw new PExceptionIO("Unexpected value: required PName: found " + o);
        }
        reservationsPName = (PName) o;
        TraceEjb.coherence.log(BasicLevel.DEBUG, "reservationsPName: " + reservationsPName);
        if (reservationsPName != null)
            TraceEjb.coherence.log(BasicLevel.DEBUG, "reservationsPName.isNull(): " + reservationsPName.isNull());
    }
    
    
    // IMPLEMENTATION OF THE com.titan.cruise.JOnASCruiseEJBCoherenceHelper INTERFACE //
    //-------------------------------------------------------------//
    public java.util.Collection jonasGetReservations() {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"return " + reservations);
        return reservations;
    }
    
    public void jonasSetReservations(java.util.Collection val) {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        if (val == null)
            throw new IllegalArgumentException("Assign a null value to a relationship");
        if (val != reservations) {
            // clear the current gen class
            reservations.clear();
            
            // iterate over the parameter to add each element into the
            // current gen class
            for(Iterator it = val.iterator(); it.hasNext();) {
                reservations.add(it.next(), false, false);
            }
            dirty = true;
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG, "END");
    }
    
    public void jonasAddReservations(com.titan.reservation.JOnASReservationEJBCoherenceHelper bean) {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        reservations.add(bean, true, false);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "END");
    }

    public void jonasRemoveReservations(com.titan.reservation.JOnASReservationEJBCoherenceHelper bean) {
        TraceEjb.coherence.log(BasicLevel.DEBUG,"");
        reservations.remove(bean, true, false);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "END");
    }
    
    public void jonasElemWrittenReservations(com.titan.reservation.JOnASReservationEJBCoherenceHelper bean) {
        reservations.doNotWrite((PObject) bean);
    }

    
    
    
    
    /*
     * ejbCreate(.....) method
     */
    public PName _ejbCreate(java.lang.String p1, com.titan.ship.ShipLocal p2)
        throws javax.ejb.CreateException
        {
            TraceEjb.interp.log(BasicLevel.DEBUG,"");
            jonasSetShip(null);
            reservations.reset();
            reservationsPName = null;
            setPkAllowed = true;
            super.ejbCreate(p1, p2);

 // If Pk is auto-incremented, we must set the value of the pk
            // Only type Integer is valid
            this.id = new Integer(factory.calculateAutomaticPk());
            setPkAllowed = false;
            PBinding pb = (PBinding) ejbContext.getEntitySwitch();
            TraceEjb.interp.log(BasicLevel.DEBUG, "pb=" + pb);
            Object conn = null;
            try {
                conn = factory.getConnection(null);
                pb.export(conn, JavaType.toObject(getId()));
                TraceEjb.interp.log(BasicLevel.DEBUG, "PName=" + pb.getPName());
                pb.write(conn, this);
                dirty = false;
                return pb.getPName();
            } catch (PExceptionExistingDSI pe) {
                throw new DuplicateKeyException(pe.getMessage());
            } catch (PExceptionExisting pe) {
                throw new DuplicateKeyException(pe.getMessage());
            } catch (PExceptionNaming pe) {
                throw new CreateException("The pk fields has not been initialized the ejbCreate method of the bean CruiseEJB");
            } catch (Exception e) {
                TraceEjb.logger.log(BasicLevel.ERROR,
                                    "Failed to create bean: ", getInnerException(e));
                throw new CreateException("Failed to create bean: " + getInnerException(e).getMessage());
            } finally {
                try {
                    if (conn != null)
                        factory.releaseConnection(conn);
                } catch (Exception e) {
                    TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to release connection", e);
                }
            }
        }
    
     
    /*
     * ejbFindByPrimaryKey(...) method
     */
    public PName ejbFindByPrimaryKey(java.lang.Integer pk)
        throws FinderException {
        TraceEjb.interp.log(BasicLevel.DEBUG,"Translate the pk into a PName");
        // Translate the pk into a PName
        Coder c = (Coder) ejbContext.getEntityFactory().getLocalHome();
        if (c == null) {
            c = (Coder) ejbContext.getEntityFactory().getHome();
        }
        PName pn = null;
        try {
            pn = c.decode(pk);
        } catch (Exception e) {
            TraceEjb.logger.log(BasicLevel.ERROR,
                                "Failed to decode the primary key:" + pk, e);
            throw new FinderException("Failed to decode the primary key:" + pk);
        }
        return ejbFindByPrimaryKey(pn);
    }

    /*
     * ejbFindByPrimaryKey(...) method
     */
    public PName ejbFindByPrimaryKey(PName pn)
        throws FinderException {
        TraceEjb.interp.log(BasicLevel.DEBUG, pn);
        PBinding pb = (PBinding) ejbContext.getEntitySwitch();
        //TraceEjb.interp.log(BasicLevel.DEBUG, "pb=" + pb);
        //TraceEjb.interp.log(BasicLevel.DEBUG, "pb.getStatus()=" + pb.getStatus());
        Object conn = null;
        try {
            conn = factory.getConnection(null);
            pb.bind(pn);
            if (!pb.exist(conn)) {
                TraceEjb.interp.log(BasicLevel.INFO,
                                    "Object not found in database (ejbFindByPrimaryKey("
                                    + pn + "))");
                pb.unbind();
                throw new ObjectNotFoundException("Object not found in database (ejbFindByPrimaryKey(" + pn + "))");
            }
            pb.unbind();
            return pn;
        } catch (ObjectNotFoundException oe) {
            throw oe;
        } catch (Exception e) {
            TraceEjb.logger.log(BasicLevel.ERROR,
                                "Failed to find bean from database in ejbFindByPrimaryKey" + pn,
                                getInnerException(e));
            throw new FinderException("Failed to find bean from database in ejbFindByPrimaryKey");
        } finally {
            //TraceEjb.interp.log(BasicLevel.DEBUG, "pb.getStatus()=" + pb.getStatus());
            try {
                if (conn != null)
                    factory.releaseConnection(conn);
            } catch (Exception e) {
                TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to release connection", e);
            }
        }
    }

     
    /*
     * ejbFindXXX(...) method returning only 1 PK
     */
    public PName ejbFindByName(java.lang.String p1)
        throws FinderException {
        TraceEjb.interp.log(BasicLevel.DEBUG, "");
        try {
            ParameterOperand[] params = new BasicParameterOperand[1+1];
            params[0] = new BasicParameterOperand(PTypeSpaceMedor.NAMING_CONTEXT, "Cmp2_Cruise._PName", factory.getPBinder());
            params[1] = new BasicParameterOperand(PTypeSpace.STRING, "?1", p1);
            TupleCollection tc = factory.evaluate(2, params);

            //Build the result
            if (tc.isEmpty()) {
                TraceEjb.interp.log(BasicLevel.INFO,
                                    "The bean was not found in the support");
                throw new ObjectNotFoundException("The bean was not found in the support");
            } else {
                PName pn = (PName) tc.getObject(1);
                //TraceEjb.interp.log(BasicLevel.DEBUG, "pn: " + pn);
                if (tc.next()) {
                    throw new FinderException("There is more than one object in response to the ${M.getCapName} single-object finder");
                } else {
                    return pn;
                }
            }
        } catch (MedorException e) {
            TraceEjb.logger.log(BasicLevel.ERROR, "Problem during the evaluation of the finder method FindByName", getInnerException(e));
            throw new FinderException("An error is occured during the evaluation of the FindByName request:"
                                      + e.getMessage());
        }
        //look in the interposition objects (local or remote) the return type !!!
    }


     
    /*
     * ejbFindXXX(...) method returning a java.util.Enumeration or a java.util.Collection
     */
    public java.util.Collection ejbFindAllCruises()
        throws FinderException {
        TraceEjb.interp.log(BasicLevel.DEBUG, "");
        try {
            ParameterOperand[] params = new BasicParameterOperand[0+1];
            params[0] = new BasicParameterOperand(PTypeSpaceMedor.NAMING_CONTEXT, "Cmp2_Cruise._PName", factory.getPBinder());
            TupleCollection tc = factory.evaluate(1, params);
            // Build the result
            ArrayList result = new ArrayList();
            if (!tc.isEmpty()) {
                do {
                    result.add(tc.getTuple().getObject(1));
                } while (tc.next());
            }
            return result;
        } catch (MedorException e) {
            TraceEjb.logger.log(BasicLevel.ERROR, "Problem during the evaluation of the finder method FindAllCruises", e);
            e.printStackTrace();
            throw new FinderException("An error is occured during the evaluation of the FindAllCruises request:"
                                      + e.getMessage());
        }
    }

     
    /*
     * setEntityContext(javax.ejb.EntityContext) method
     */
    public void setEntityContext(javax.ejb.EntityContext p1)
        {
            dirty = true;
            setPkAllowed = false;
            ejbContext = (JEntityContext) p1;
            if (factory==null) {
                factory = (MedorFactory) ejbContext.getEntityFactory();
                PClassMapping gcm = null;
                //initialize the multivalued relation reservations
                reservations = new org.objectweb.jonas_ejb.container.jorm.Set();
                gcm = factory.getGenClassMapping("reservations");
                reservations.setPClassMapping(gcm);
                reservations.setListener(new reservationsOfCruiseEJBListener(this));
                try {
                    reservations.setPBinding(gcm.createPBinding());
                } catch (PException e) {
                    TraceEjb.interp.log(BasicLevel.ERROR,
                                        "Impossible to create a PBinding for the relation reservations", e);
                    throw new EJBException("Impossible to create a PBinding for the relation reservations", e);
                }
            }
            super.setEntityContext(p1);
        }
    
     
    /*
     * ejbActivate() method
     */
    public void ejbActivate()
        {
            dirty = true;
            setPkAllowed = false;
            super.ejbActivate();
        }

     
    /*
     * ejbLoad() method
     */
    public void ejbLoad()
        {
            Object conn = null;
            PBinding pb = (PBinding) ejbContext.getEntitySwitch();
            try {
                conn = factory.getConnection(null);
                pb.bind((PName) ((JEntitySwitch) pb).getPrimaryKey());
                TraceEjb.interp.log(BasicLevel.DEBUG, pb.getPName());
                pb.read(conn, this);
                pb.unbind();
                // load the multivalued relations reservations
                reservations.read(reservationsPName, conn);
                dirty = false;
            } catch (Exception e) {
                TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to load", getInnerException(e));
                throw new EJBException(getInnerException(e));
            } finally {
                //TraceEjb.interp.log(BasicLevel.DEBUG, "pb.getStatus()=" + pb.getStatus());
                try {
                    if (conn != null)
                        factory.releaseConnection(conn);
                } catch (Exception e) {
                    TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to release connection", e);
                }
            }
            super.ejbLoad();
        }

     
    /*
     * ejbStore() method
     */
    public void ejbStore()
        {
            if (dirty
                || reservations.gcIsModified()
                ) {
                // The bean or a gen class has been modified
                // ==> The first allocates a connection which will be shared to
                // store the modified objects
                Object conn = null;
                TraceEjb.interp.log(BasicLevel.DEBUG, "");
                try {
                    PName pn = null;
                    if (dirty) {
                        TraceEjb.interp.log(BasicLevel.DEBUG, "Store the bean");
                        conn = factory.getConnection(null);
                        // The bean has been modified
                        super.ejbStore();
                        PBinding pb = (PBinding) ejbContext.getEntitySwitch();
                        pn = (PName) ((JEntitySwitch) pb).getPrimaryKey();
                        pb.bind(pn);
                        TraceEjb.interp.log(BasicLevel.DEBUG, "PName=" + pb.getPName());
                        pb.write(conn, this);
                        pb.unbind();
                        dirty = false;
                    }
                    if (reservations.gcIsModified()) {
                        if ( reservationsPName==null) {
                            if (pn == null)
                                pn = (PName) ejbContext.getEntitySwitch().getPrimaryKey();
                            try {
                                reservationsPName = factory.getPNameManager("reservations")
                                                  .export(conn, reservations.gcGetPBinding(), pn);
                            } catch (PExceptionIO e) {
                                throw e;
                            } catch (PException e) {
                                throw new PExceptionIO(e, "Impossible to fetch a PName of the 'reservations' field");
                            }
                        }
                        TraceEjb.interp.log(BasicLevel.DEBUG, "Store the gen class reservations");
                        if (conn == null)
                            conn = factory.getConnection(null);
                        // store the multivalued relations reservations
                        // because it has been modified
                        reservations.write(reservationsPName, conn);
                    }
                } catch (Exception e) {
                    TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to store", getInnerException(e));
                    throw new EJBException(e);
                } finally {
                    try {
                        if (conn != null)
                            factory.releaseConnection(conn);
                    } catch (Exception e) {
                        TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to release connection", e);
                    }
                }
            }
        }

     
    /*
     * ejbRemove() method
     * This implementation unexports the bean, and remove the data on the
     * support.
     */
    public void ejbRemove()
        throws javax.ejb.RemoveException
        {
            TraceEjb.interp.log(BasicLevel.DEBUG, "");
            super.ejbRemove();
             setShip(null); // MO
             reservations.gcClear(true); // OM
            PBinding pb = (PBinding) ejbContext.getEntitySwitch();
            Object conn = null;
            try {
                conn = factory.getConnection(null);
                PName pn = (PName) ((JEntitySwitch) pb).getPrimaryKey();

                TraceEjb.interp.log(BasicLevel.DEBUG, "Remove the bean " + pn);
                pb.bind((PName) ((JEntitySwitch) pb).getPrimaryKey());
                pb.unexport(conn);
                pb.write(conn, this);
                pb.unbind();

                TraceEjb.interp.log(BasicLevel.DEBUG, "Remove the multivalued CMR reservations");
                if ( reservationsPName == null) {
                    reservationsPName = factory.getPNameManager("reservations")
                                      .export(conn, reservations.gcGetPBinding(), pn);
                }
                pb = reservations.gcGetPBinding();
                pb.bind(reservationsPName);
                pb.unexport(conn);
                reservations.write(reservationsPName, conn);
                pb.unbind();
                dirty = false;
            } catch (Exception e) {
                TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to remove", getInnerException(e));
                throw new RemoveException(e.getMessage());
            } finally {
                try {
                    if (conn != null)
                        factory.releaseConnection(conn);
                } catch (Exception e) {
                    TraceEjb.logger.log(BasicLevel.ERROR, "Impossible to release connection", e);
                }
            }
        }

  
    /**
     * This method is used to reach a referenced bean with its pname.
     */
    private Object getPObject(PName pn, boolean useLocal) throws PException {
        TraceEjb.interp.log(BasicLevel.DEBUG, "Search PObject with the pnane:" + pn);
        if (pn == null || pn.isNull()) {
            return null;
        }
        PBinder f = (PBinder) pn.getPNameManager();
        JEntityFactory ef = (JEntityFactory) f.getBinderClassMapping();
        if (useLocal) {
            return ((PObjectHome) ef.getLocalHome()).getPObject(pn);
        } else {
            return ((PObjectHome) ef.getHome()).getPObject(pn);
        }
    }

    // IMPLEMENTATION OF THE PAccessor INTERFACE //

    public Object getMemoryInstance() {
        return this;
    }

    private static Exception getInnerException(Exception e) {
        boolean last = false;
        Exception res = e;
        while (!last) {
            if (res instanceof PException
                && ((PException) res).getNestedException() != null) {
                res = ((PException) res).getNestedException();

            } else if (res instanceof MedorException
                       && ((MedorException) res).getNestedException() != null) {
                res = ((MedorException) res).getNestedException();

            } else if (res instanceof EJBException
                       && ((EJBException) res).getCausedByException() != null) {
                res = ((EJBException) res).getCausedByException();

            } else
                last = true;
        }
        return res;
    }
}


/**
 * Listener on modifications made on reservations
 */
class reservationsOfCruiseEJBListener implements GenClassListener {

    private JOnASCruiseEJBBean bean;

    protected reservationsOfCruiseEJBListener(JOnASCruiseEJBBean bean) {
        this.bean = bean;
    }

    /**
     * An Element has been added
     */
    public void gcAdd(GenClassElement gce) {
        TraceEjb.coherence.log(BasicLevel.DEBUG, "gce.value=" + gce.value);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "gce.pname=" + gce.pname);
        com.titan.cruise.JOnASCruiseEJBCoherenceHelper localBean =
                                        ((com.titan.reservation.JOnASReservationEJBCoherenceHelper) gce.value)
                                        .jonasGetCruise();
        if (localBean != null) {
            TraceEjb.coherence.log(BasicLevel.DEBUG, "remove the old relation with the element (" + localBean + ")");
            localBean.jonasRemoveReservations((com.titan.reservation.JOnASReservationEJBCoherenceHelper) gce.value);
        }
        TraceEjb.coherence.log(BasicLevel.DEBUG, "Assign the opposite cmr field(set this)");
        ((com.titan.reservation.JOnASReservationEJBCoherenceHelper) gce.value)
            .jonasSetCruise((com.titan.cruise.JOnASCruiseEJBCoherenceHelper)
                                                  bean.ejbContext.getEJBLocalObject()
                                                  );
        
        TraceEjb.coherence.log(BasicLevel.DEBUG, "END");
    }

    /**
     * An element has been removed
     */
    public void gcRemove(GenClassElement gce, boolean delete) {
        TraceEjb.coherence.log(BasicLevel.DEBUG, "gce.value=" + gce.value);
        TraceEjb.coherence.log(BasicLevel.DEBUG, "gce.pname=" + gce.pname);
        
            ((com.titan.reservation.JOnASReservationEJBCoherenceHelper) gce.value).jonasSetCruise(null);

        TraceEjb.coherence.log(BasicLevel.DEBUG, "END");
    }

    /**
     * @return true if must signal remove.
     */
    public boolean mustSignalRemoved() {
        return true;
    }

    /**
     * An element has been written
     */
    public void gcElemWritten(GenClassElement gce) {
    }

}
