/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mapping are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2002 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Release: 1.0
 *
 * Contact: pascal.dechamboux@rd.francetelecom.com
 *
 * Authors: R. Basset, S. Chassande-Barrioz, P. Dechamboux, N. De Palma,
 *          A. Lefebvre, X. Spengler.
 *
 */

package jorm;

import org.objectweb.jorm.api.PAccessor;
import org.objectweb.jorm.api.PException;

public interface Cmp2_CreditCardAccessor extends PAccessor {

	//Accessors to the creditOrganization field
	public void paSetCreditOrganization(java.lang.String val) throws PException;
	public java.lang.String paGetCreditOrganization() throws PException;

	//Accessors to the expirationDate field
	public void paSetExpirationDate(java.util.Date val) throws PException;
	public java.util.Date paGetExpirationDate() throws PException;

	//Accessors to the nameOnCard field
	public void paSetNameOnCard(java.lang.String val) throws PException;
	public java.lang.String paGetNameOnCard() throws PException;

	//Accessors to the number field
	public void paSetNumber(java.lang.String val) throws PException;
	public java.lang.String paGetNumber() throws PException;

	//Accessors to the id field
	public void paSetId(java.lang.Integer val) throws PException;
	public java.lang.Integer paGetId() throws PException;

	//Accessors to the customer field
	public void paSetCustomer(Object val, Object connection) throws PException;
	public Object paGetCustomer(Object connection) throws PException;
}